function browse(Data, dim)
%browse(Data, dim)
% Graphical display of patterns
% Data -- a data object
% dim  -- dimension of the patterns (1 = vector, 2= square image)

% Isabelle Guyon -- isabelle@clopinet.com -- May 2007

if nargin<2, dim=1; end

n=1;
p=-1;
e=0;
figure('name', 'Pattern browser');
num=1;
while 1

    if dim==2,
        show_digit(Data.X(num,:));   
    else
        plot(Data.X(num,:));
    end

    if isempty(Data.Y)
        title(['Index: ' num2str(num)]);
    else
        title(['Index: ' num2str(num) ' Class: ' num2str(Data.Y(num))]);
    end
    
    idx = input('Pattern number (or n for next, p for previous, e exit)? ');
    if isempty(idx), idx=n; end
    switch idx
    case n
        num=min(num+1,size(Data.X, 1));
    case p
        num=max(1,num-1);
    case e
        break
    otherwise
        num=idx;
    end
end


