% Demo1.m
% Feature Selection Lab1
% Amir Saffari, amir@ymer.org
% ----------------------

%% 1) Configuration
clear all
addpath( genpath( pwd ) );

%% 2) Load the dataset:
load demoData1

demoData
demoData.train

figure
posClassIndex  = demoData.train.Y > 0;
negClassIndex  = demoData.train.Y < 0;
plot( demoData.train.X( posClassIndex , 1) , demoData.train.X( posClassIndex , 2) , '.' )
hold on
plot( demoData.train.X( negClassIndex , 1) , demoData.train.X( negClassIndex , 2) , 'r.' )
hold off

%% 3) Train
myModel = svc( { 'coef0=0' , 'degree=1' , 'gamma=0' , 'shrinkage=1' } )
[ trainOutput , myModel ] = train( myModel , demoData.train )
BER   = balanced_errate( trainOutput.X , trainOutput.Y )
EBAR  = error_bar( BER , length( find( trainOutput.Y > 0 ) ) )

figure
posClassIndex  = trainOutput.X > 0;
negClassIndex  = trainOutput.X < 0;
plot( demoData.train.X( posClassIndex , 1) , demoData.train.X( posClassIndex , 2) , '.' )
hold on
plot( demoData.train.X( negClassIndex , 1) , demoData.train.X( negClassIndex , 2) , 'r.' )
hold off
title( 'Training results' )

%% 4) Test
testOutput  = test( myModel , demoData.test );
BER   = balanced_errate( testOutput.X , testOutput.Y )
EBAR  = error_bar( BER , length( find( testOutput.Y > 0 ) ) )

figure
posClassIndex  = testOutput.X > 0;
negClassIndex  = testOutput.X < 0;
plot( demoData.test.X( posClassIndex , 1) , demoData.test.X( posClassIndex , 2) , '.' )
hold on
plot( demoData.test.X( negClassIndex , 1) , demoData.test.X( negClassIndex , 2) , 'r.' )
hold off
title( 'Test results' )