function [filter1, filter2]=compare_filters(filter1, filter2, dat)
% [filter1, filter2]=compare_filters(filter1, filter2, dat)
% Compare two filters
% filter1   -- A first filter object.
% filter2   -- A second filter object.

%== get names ==
name1=get_name(filter1);
sp=findstr(name1, 'f_');
if ~isempty(sp), 
    name1=name1(1:sp(1)-1); 
else
    name1=[name1 '1'];
end
name2=get_name(filter2);
sp=findstr(name2, 'f_');
if ~isempty(sp), 
    name2=name2(1:sp(1)-1); 
else
    name2=[name2 '2'];
end

%== train ==
[dt,filter1]=train(filter1, dat);
clear dt; % save memory
[dt,filter2]=train(filter2, dat);
clear dt; % save memory

% == Overlay the results: analytic=red; probe=blue ==
figure; 
plot(get_pval(filter1,1)); 
title(['p-values (' name1 '=blue; ' name2 '=red)']); 
xlabel('rank'); 
ylabel('pval');
hold on; 
plot(get_pval(filter2,1), 'r');

figure; plot(get_fdr(filter1,1)); 
title(['FDR (' name1 '=blue; ' name2 '=red)']); 
xlabel('rank'); 
ylabel('FDR');
hold on; 
plot(get_fdr(filter2,1), 'r');