function [filters]=compare_n_filters(filters, dat)
% [filters]=compare_filters(filters, dat)
% Compare filters
% filters   -- An array of filter objects.

col='rgbkmc';
colname={'red', 'green', 'blue', 'black', 'magenta', 'cyan'};

%== get names ==
for k=1:length(filters)
    nm=get_name(filters{k});
    sp=findstr(nm, 'f_');
    name{k}=nm(1:sp(1)-1);
end

%== train ==
for k=1:length(filters)
    [dt,filters{k}]=train(filters{k}, dat);
    clear dt; % save memory
end

% == Overlay the results ==
figure; hold on
ttl='p-values (';
for k=1:length(filters)
    plot(get_pval(filters{k},1), col(k)); 
    ttl=[ttl ' ' name{k} '=' colname{k}];
end
ttl=[ttl ')'];
title(ttl);
xlabel('rank'); 
ylabel('pval');

figure; hold on
ttl='FDR (';
for k=1:length(filters)
    plot(get_fdr(filters{k},1), col(k)); 
    ttl=[ttl ' ' name{k} '=' colname{k}];
end
ttl=[ttl ')'];
title(ttl);
xlabel('rank'); 
ylabel('FDR');

